﻿package com.Tutorial 
{
    import com.adamatomic.flixel.*;
	import com.adamatomic.flixel.data.FlxLogoPixel;
	
	/**
	 * ...
	 * @author Stephen Lavelle
	 */
	public class BattleState extends FlxState
	{ 
	    [Embed(source = '../../data/gfx/battleframe.png')] static public var GfxBattleFrame:Class;

		private var _d1:FlxArray;
		private var _d2:FlxArray;
		public static var s1:int;
		public static var s2:int;
		private var _r:int;
		
		private var _r1:int;
		private var _r2:int;
		
		private var _roll1:FlxText;
		private var _roll2:FlxText;
		private var _score1:FlxText;
		private var _score2:FlxText;
		private var _round:FlxText;
		
		public static var lyrBG:FlxLayer;
		public static var lyrFG:FlxLayer;
		
		public static var matchCount:int;
		public static var dieCount:int;
		public static var targetDie:int;
		
		public function BattleState()
		{
			matchCount++;
			
			FlxG.setMusic(MenuState.SndBattle);
			lyrBG = new FlxLayer();
			lyrFG = new FlxLayer();
			
			var npc:NPC;
			trace("toinspect", WalkState.toInspect);
			npc = new NPC(5 + 2, 22 + 2, WalkState.toInspect);
			
			var p1:FlxSprite;
			p1 = new FlxSprite(Player.ImgPlayer, 5 + 2, 89 + 2, false, false, 16, 16);
			p1.addAnimation("a", [1]);
			p1.play("a");
			p1.specificFrame(1);
			p1.update();
			
			lyrBG.add(new FlxSprite(GfxBattleFrame, 74, 23));
			lyrBG.add(new FlxSprite(InspectState.GfxSmallFrame,5, 22));
			lyrBG.add(new FlxSprite(InspectState.GfxSmallFrame,5+20, 22+24));
			lyrBG.add(new FlxSprite(InspectState.GfxDice,5+20+2, 22+24+2));
			lyrBG.add(new FlxSprite(InspectState.GfxSmallFrame,5, 89));
			lyrBG.add(new FlxSprite(InspectState.GfxSmallFrame, 5 + 20, 89 + 24));
			lyrBG.add(new FlxSprite(InspectState.GfxDice,5+20+2, 89+24+2));
		
			lyrBG.add(npc);
			lyrBG.add(p1);
		
			lyrBG.add(new FlxText(5 + 25, 20 + 6, 100, 100, npc.ownername, 0xff8d431f));
			lyrBG.add(new FlxText(5 + 43, 20 + 24, 100, 100, npc.diename, 0xff8d431f));
			lyrBG.add(new FlxText(5 + 43, 20 + 24+10, 100, 100, npc.nums, 0xff8d431f));

			var npc2:NPC;
			npc2 = new NPC(0,0,ChooseDieState.chosendie);
			
			lyrBG.add(new FlxSprite(null, 0, 0, false, false, FlxG.width, 16, 0xff8d431f));
			lyrBG.add(new FlxText(32, 2, 100, 8, "BATTLE!", 0xfff36f36));

			
			lyrBG.add(new FlxText(5 + 25, 86+ 6, 100, 100, "Lucile", 0xff8d431f));
			lyrBG.add(new FlxText(5 + 43, 86+ 24, 100, 100, npc2.diename, 0xff8d431f));
			lyrBG.add(new FlxText(5 + 43, 86 + 24+10, 100, 100, npc2.nums, 0xff8d431f));

			lyrBG.add(new FlxText(113, 22, 100, 100, "Roll", 0xff8d431f));
			lyrBG.add(new FlxText(113, 104, 100, 100, "Roll", 0xff8d431f));
			lyrBG.add(new FlxText(76, 74, 100, 100, "Round", 0xff8d431f));
					
			_roll1 = new FlxText(112,35,25,20,"0",0xff8d431f,null,16,"right");
			_roll2 = new FlxText(112,117,25,20,"0",0xff8d431f,null,16,"right");
			
			_score1 = new FlxText(102, 58, 100, 100, "score: 0", 0xff8d431f);
			_score2 = new FlxText(102, 89, 100, 100, "score: 0", 0xff8d431f);
			
			_round = new FlxText(75, 74, 82, 10, "23", 0xff8d431f, null, 8, "right");
			
			_roll1.visible = false;
			_roll2.visible = false;
			_round.visible = false;
			
			lyrBG.add(_roll1);
			lyrBG.add(_roll2);
			lyrBG.add(_score1);
			lyrBG.add(_score2);
			lyrBG.add(_round);
			
			this.add(lyrBG);
			this.add(lyrFG);
			
			s1 = 0;
			s2 = 0;
			_r = -1;
			
			_d1 = new FlxArray();
			for (var i:int = 0; i < npc.nums.length; i++)
			{
				_d1.push(int(npc.nums.charAt(i)));
			}
			targetDie = npc.npcIndex;
			
			_d2 = new FlxArray();
			for (i = 0; i < npc2.nums.length; i++)
			{
				_d2.push(int(npc2.nums.charAt(i)));
			}
			
			FlxG.flash(0xffff0000, 1, flashover1, true);
		}
		
	
		private function flashover1():void
		{
			FlxG.flash(0x01000000, 1, flashover2, true);
		}
		
		
		private function flashover2():void
		{
			_r++;
			if (_r == 21)
			{				
				if (s1 > s2)			
					FlxG.fade(0xffff0000, 1, sceneover, true);			
				else if (s1 < s2)
					FlxG.fade(0xff00ffff, 1, sceneover, true);			
				else				
					FlxG.fade(0xff888888, 1, sceneover, true);		
			}
			else
			{
				_round.visible = true;
				_round.setText(_r.toString());
				_roll1.visible = false;
				_roll2.visible = false;
			
				FlxG.flash(0x01101010, 1 / (_r + 1), flashover3, true);			
			}
		}
		
		private function flashover3():void
		{
			_r1 = FlxArray.getRandom(_d1) as int;
			_r2 = FlxArray.getRandom(_d2) as int;
			_roll1.setText(_r1.toString());
			_roll2.setText(_r2.toString());
			_roll1.visible = true;
			_roll2.visible = true;
			
			FlxG.flash(0x01101010, 1/(_r+1), flashover4, true);			
		}
		
		
		private function flashover4():void
		{
			if (_r1 > _r2)
			{
				FlxG.flash(0xff000000, 0.2);
				s1++;
			}
			else if (_r1 < _r2)
				s2++;
			_score1.setText("score: " + s1.toString());
			_score2.setText("score: " + s2.toString());
			_score1.visible = true;
			_score2.visible = true;
			FlxG.flash(0x01101010, 1/(_r+1), flashover2, true);			
		}
		
		public function sceneover():void
		{
			FlxG.switchState(BattleOver);
		}
		override public function update():void
		{
		
		}
	}

}